// Implementazione di una lista con una serie di nodi allocata dinamicamente

// sezione di include generali
#include <stdio.h>
#include <stdlib.h>


#define VERO 0
#define FALSO 1

// definizione della struttura NODO
typedef struct nodo
   {
   int Info;
   struct nodo *pNext;
   } NODO;



// programma principale
int main(int argc, char *argv[])
{
// dichiaraziuone variabili locali
NODO *pTesta;
NODO *pCur;
NODO *pNew;
int continua, i;
char risp;
// variabili per ricerca
int pos, ele;
int trovato;

// inizializzazioni
pTesta = NULL;
pCur = NULL;
pNew = NULL;

// Richiesta acquisisizione nodo
printf("Vuoi inserire il primo nodo nodo? (S/N)");                  
fflush(stdin);               
scanf("%char",&risp);

i = 1;
continua = FALSO;


do
   {
   if ((i == 1)&&(toupper(risp) == 'S'))
      {
      // Allocazione dinamica primo nodo            
      pNew = (NODO*) malloc (sizeof(NODO));
      if (pNew != NULL)
         {
         // acquisisco la parte informativa del primo nodo
         printf("Immetti il valore del %d^ nodo: ", i);
         fflush(stdin);
         scanf("%d",&(pNew->Info));
         // equivalente a scanf("%d",&((*pNew).Info));
            
         // salvo il puntatore alla testa della lista - SOLO PRIMO NODO
         pCur = pNew;
         pTesta = pCur;
         continua = VERO;
         }
      else
         {
         continua = FALSO;      
         printf("Errore di allocazione primo nodo!\n");    
         }      
      }
   else
      {
      if (toupper(risp) == 'S')
         {
         // Allocazione dinamica nodi successivi            
         pNew = (NODO*) malloc (sizeof(NODO));
         if (pNew != NULL)
            {
            // acquisisco la parte informativa dell'iesimo nodo
            printf("Immetti il valore del %d^ nodo: ", i);
            fflush(stdin);
            scanf("%d",&(pNew->Info));
            // equivalente a scanf("%d",&((*pNew).Info));
          
            // Collego il nodo precedente a quello appena allocato
            pCur->pNext = pNew;
            // equivalente a (*pCur).pNext = pNew;
         
            // Aggiorno il puntatore al nodo precedente allocato
            pCur = pNew;  
            }
         else
            {
            continua = FALSO;      
            printf("Errore di allocazione nodo successivo!\n");    
            }   
         }    
      else
         {            
         }       
      }              
   if (toupper(risp) == 'S')
      {
      // Richiesta acquisizione nodo
      printf("Vuoi inserire un altro nodo? (S/N)");                  
      fflush(stdin);               
      scanf("%char",&risp);
      
      // aggiorno il numero dei nodi
      i = i + 1; 
      }    
   }
while (toupper(risp) == 'S');
   
// Concludo la lista
if (continua == VERO)
   {
   (pCur->pNext) = NULL;
   }

// Stampo la lista linkata solo se  tutto andato bene
if (continua == VERO)   
   {
   printf ("\n 1) Costruzione della lista linkata terminata con successo!");
       
   // visualizzazione della lista linkata
   printf("\n\n 2) Visualizzazione della lista linkata\n\n"); 
   pCur = pTesta;
   while (pCur != NULL)
      {
      // stampo a video il contenuto informativo         
      printf(" %d ",pCur->Info);
      // equivalente a printf(" %d ", (*pCur).Info);
   
      // mi sposto sul nodo successivo
      pCur = (pCur->pNext);
      // equivalente a pCur = (*pCur).pNext;  
      }

   // ricerca elemento nella lista linkata
   printf("\n\n 3) Ricerca di un elemento nella lista linkata\n\n"); 
   
   //ricerca di un elemento nella lista
   trovato = FALSO;
   i = 0;
   pos = 0;
   pCur = pTesta;
   
   // Richiesta acquisizione nodo
   printf("    Elemento da trovare? ");                  
   fflush(stdin);               
   scanf("%d",&ele);
   
   // scansione condizionata
   while ((trovato == FALSO)&&(pCur != NULL))
      {
      i = i + 1;
      if (ele == (pCur->Info))
         {
         trovato = VERO;
         pos = i;   
         }
      pCur = (pCur -> pNext);
      }
            
   // valutazione esito ricerca        
   if (trovato == VERO)
      {
      printf("    Elemento %d trovato in posizione %d",ele, pos);     
      }
   else
      {
      printf("    Elemento non presente nella lista");     
      }
      
   // ricerca elemento nella lista linkata con conteggio occorrenze
   printf("\n\n 4) Ricerca di un elemento nella lista linkata conteggio occorrenze\n\n"); 
   
   //ricerca di un elemento nella lista
   trovato = FALSO;
   i = 0;
   pCur = pTesta;
   
   // Richiesta acquisizione nodo
   printf("    Elemento da trovare? ");                  
   fflush(stdin);               
   scanf("%d",&ele);
   
   // scansione condizionata
   while (pCur != NULL)
      {
      if (ele == (pCur->Info))
         {
         trovato = VERO;
         i = i + 1;   
         }
      pCur = (pCur -> pNext);
      }
         
    // valutazione esito ricerca        
    if (trovato == VERO)
       {
       printf("    Elemento %d trovato nella lista %d ",ele, i);
       if ( i == 1)
          {
          printf("volta");
          }
       else
          {
          printf("volte");
          }            
       }
    else
       {
       printf("    Elemento non presente nella lista");
       }        
         
   // deallocazione della lista linkata
   pCur = pTesta;
   while (pCur != NULL)
      {
      pTesta = pCur->pNext;
      // equivalente a pTesta = (*pCur).pNext;  
      free(pCur);
      pCur = pTesta;
      }     
   printf("\n\n\n 5) Deallocazione della lista linkata terminata con successo!\n\n");            
   }
else
   {
   printf ("\nCostruzione della lista NON terminata con successo!");    
   }                     

printf("\n\n");
system("PAUSE");

return 0;
}
